#
# Copyright (C) 2006 Takashi Nakamoto <bluedwarf@bpost.plala.or.jp>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

module ScimRubyObject
  def to_scimruby
    # return string to be commited by scim-ruby
    to_s
  end
end

class Object
  include ScimRubyObject
end

class Array
  def to_scimruby
    join(",").toutf8
  end
end

class Hash
  def to_scimruby
    ret = ""
    each{ |key, val| ret += "#{key}: #{val}\n".toutf8 }
    ret
  end
end

class String
  def to_scimruby
    toutf8
  end
end

class File
  def to_scimruby
    ""
  end
end

$scim_ruby_joke_number=0
def scim_ruby_exception_handler(e)
  begin
    raise e
  rescue SystemExit
    $scim_ruby_joke_number = $scim_ruby_joke_number + 1
    case $scim_ruby_joke_number
    when 1
      "Oh, no! Do you realy want to kill scim-ruby?"
    when 2
      "You must be a perl monger."
    when 3
      "Bloody hell! You can't be serious!"
    when 4
      "Are you looking for a fight?"
    else
      "My name is Takashi Nakamoto."
    end
  rescue Exception
    e.message
  end
end

def scim_ruby_credit
  authors = ["Takashi Nakamoto <bluedwarf@bpost.plala.or.jp>"]
  contributors = [""]

  ret = "Authors: \n"
  ret += authors.join("\n")
  ret += "\nContributor: \n"
  ret += contributors.join("\n")
end

=begin
$enable_gtk2 = require "gtk2"
$clipboard = ""
if $enable_gtk2

  Gtk::Clipboard.get(Gdk::Display.default, Gdk::Selection::CLIPBOARD).request_text{ |cb, text|
    $clipboard = text
    f=open("/home/bluedwarf/clipboard", "w")
    f.puts text
    f.close
  }
end
=end

=begin
def clipboard
  if $enable_gtk2
    Gtk::init
#    Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD).wait_for_text
    Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD
    $clipboard
  else
    ""
  end
end

def selection
  if $enable_gtk2
    Gtk::init
    Gtk::Clipboard.get(Gdk::Selection::PRIMARY).wait_for_text
  else
    ""
  end
end
=end
